<?php
# $Id: general.php,v 1.1.1.1 2005/08/10 12:14:03 yoshis Exp $
// Written by James Flemer
// For eGrad2000.com
// <jflemer@alum.rpi.edu>

$surveyFrom = new bmSurveyHtmlForms();
	
unset($sid);
$sid = $_SESSION['survey_id'];
// load current values from DB if $sid exists (in session)
$survey = array();
if(!empty($sid) && $updated) {
	$sql = "SELECT * FROM ".TABLE_SURVEY." WHERE id='${sid}'";
	$result = mysql_query($sql);
	$survey = mysql_fetch_array($result,MYSQL_ASSOC);
	mysql_free_result($result);
	if ( isset($_POST['rid']) && $_POST['rid']!='' ) $survey['response_id'] = intval($_POST['rid']);
} else {
	$fields = array('name','realm','title','subtitle','email','theme','thanks_page','thank_head','thank_body','info','public','response_id');
   	foreach ($fields as $f) {
        if(!empty($_POST[$f]))
    	    $survey[$f] = _stripslashes($_POST[$f]);
        else
            $survey[$f] = '';
    }
}
$realms = array();
if($_SESSION['acl']['superuser'] == 'Y') {
	$realms = $member_handler->getGroupList(); 
} else {
	foreach($_SESSION['acl']['pdesign'] as $r)
		$realms[$r] = $r;
}
$send_array = array(_MD_FROM_OPTION_0,_MD_FROM_OPTION_1,_MD_FROM_OPTION_2);
$themes_array = array();
$dir = dir($ESPCONFIG['css_path']);
$dir->rewind();
while ($file=$dir->read()) {
	if (stristr($file,".css")) {
		$pos = strrpos($file, ".");
		$name = substr($file, 0,$pos);
		$themes_array[$file] = $name;
	}
}
$dir->close();

$tpl_vars['content']['tab'] = array(
	'title' => _GT_General,
	'name' => 'general',
	'description' => _GT_The_information_on_this_tab_applies_to_the_whole_survey
);
$tpl_vars['content']['generalInfos'] = array(
	'name' => array(
		'label' => _GT_Name,
		'type' => 'text',
		'input' => $surveyFrom->mktext('name', 20, 64, $survey),
		'required' => 1,
		'restrictions' => array(_GT_no_spaces, _GT_alpha_numeric_only),
		'description' => _GT_This_is_used_for_all_further_access_to_this_survey
	),
	'owner'=>array(
		'label' => _GT_Owner,
		'type' => 'composition',
		'subInfos' => array(
			'user' => array(
				'label' => '',
				'type' => 'determinate',
				'required' => 0,
				'input' => $xoopsUser->uname()
			),
			'group' => array(
				'label' => '',
				'type' => 'select',
				'required' => 1,
				'input' => $surveyFrom->mkselect('realm',$realms, $survey)
			)
		),
		'description' => _GT_User_and_Group_that_owns_this_survey
	),
	'title' => array(
		'label' => _GT_Title,
		'type' => 'text',
		'input' => $surveyFrom->mktext('title', 60, 60, $survey),
		'required' => 1,
		'restrictions' => array(_GT_free_form_including_spaces),
		'description' => _GT_This_appears_at
	),
	'subtitle' => array(
		'label' => _GT_Subtitle,
		'type' => 'text',
		'input' => $surveyFrom->mktext('subtitle', 60, 128, $survey),
		'required' => 0,
		'restrictions' => array(_GT_free_form_including_spaces),
		'description' => _GT_Appears_below_the_title
	),
	'info' => array(
		'label' => _GT_Additional_Info,
		'type' => 'textarea',
		'input' => $surveyFrom->mktextarea('info', 5, 60, 'virtual', $survey),
		'required' => 0,
		'restrictions' => array(_GT_free_form_including_spaces),
		'description' => _GT_Text_to_be_displayed_on_this_survey_before_any_fields
	),
	'thanks_page' => array(
		'label' => _GT_Confirmation_Page,
		'type' => 'composition',
		'subInfos' => array(
			'thanks_url' => array(
				'label' => 'URL',
				'type' => 'text',
				'input' => $surveyFrom->mktext('thanks_page', 60, 255, $survey),
				'required' => 0,
				'restrictions' => array(),
				'description' => _GT_The_URL_to_which_a_user_is_redirected_after_completing_this_survey
			),
			'thank_head' => array(
				'label' => _GT_heading_text,
				'type' => 'text',
				'input' => $surveyFrom->mktext('thank_head', 30, 0, $survey),
				'required' => 0,
				'restrictions' => array(),
				'description' => _GT_Heading_in_bold
			),
			'thank_body' => array(
				'label' => _GT_body_text,
				'type' => 'textarea',
				'input' => $surveyFrom->mktextarea('thank_body', 5, 60, 'virtual', $survey),
				'required' => 0,
				'restrictions' => array(),
				'description' => _GT_Heading_in_bold
			)
		),
		'description' => _GT_URL_if_present
	),
	'email' => array(
		'label' => _GT_Email,
		'type' => 'text',
		'input' => $surveyFrom->mktext('email', 30, 0, $survey),
		'required' => 0,
		'restrictions' => array(),
		'description' => _GT_Sends_a_copy
	),
	'from_option' => array(
		'label' => _GT_From_Option,
		'type' => 'select',
		'input' => $surveyFrom->mkselect('from_option',$send_array, $survey),
		'required' => 0,
		'restrictions' => array(),
		'description' =>  _MD_FROM_OPTION
	),
	'response_id' => array(
		'label' => _GT_Default_Response,
		'type' => 'text',
		'required' => 0,
		'input' => $surveyFrom->mktext('response_id',10,0, $survey),
		'description' => _MD_FROM_DEFRES
	),
	'options' => array(
		'label' => _GT_Options,
		'type' => 'composition',
		'subInfos' => array(
			'resume' => array(
				'label' => _GT_Allow_to_save,
				'type' => 'checkbox',
				'input' => $surveyFrom->mkcheckbox('options','resume'),
				'required' => 0,
				'restrictions' => array()
			),
			'navigate' => array(
				'label' => _GT_Allow_to_forward,
				'type' => 'checkbox',
				'input' => $surveyFrom->mkcheckbox('options','navigate'),
				'required' => 0,
				'restrictions' => array()
			)
		)
	)
);
$tpl_vars['langs']['required'] = _GT_Required;
$tpl_vars['langs']['or'] = _GT_OR;




?>