<?php
# $Id: questions.php,v 1.1.1.1 2005/08/10 12:14:03 yoshis Exp $
// Written by James Flemer
// For eGrad2000.com
// <jflemer@alum.rpi.edu>

include_once('./class/bmSurveyHtmlForms.class.php');
$surveyFrom = new bmSurveyHtmlForms();

if(empty($_SESSION['curr_q'])) $_SESSION['curr_q'] = 0;
if(empty($_POST['id'])) $_POST['id'] = 0;
$curr_q =& $_SESSION['curr_q'];
$sid =& $_SESSION['survey_id'];
$id = intval($_POST['id']);

if (isset($_POST['type_id']))
    $_POST['type_id'] = intval($_POST['type_id']) ?
            $_POST['type_id'] : '';
else
    $_POST['type_id'] = '';

// build array of question IDs
$sql = "SELECT id,type_id,name FROM ".TABLE_QUESTION." WHERE survey_id='$sid' AND deleted='N' AND type_id != 99 ORDER BY position";
$result = mysql_query($sql);
$total_num_q = mysql_num_rows($result);
$q_ids = array();
$qn_ids = array();
$qn_name = array();
$qn_typeid = array();
while(list($qi,$tid,$qc) = mysql_fetch_row($result)){
	$q_ids[] = $qi;
	$qn_name[] = $qc;
	$qn_typeid[] = $tid;
	if ($tid<50) $qn_ids[] = $qi;
}
mysql_free_result($result);

// update failed, stay on same question
if(!$updated || isset($_POST['extra_choices'])) {
	for ( $q = 0; $q < $total_num_q && $q_ids[$q] != $id ; $q++);
	$_POST['q'] = ++$q;
	unset($q);
} else {
	if(empty($_POST['q']))
		$_POST['q'] = $curr_q;
	if($_POST['q'] == _GT_New_Field)
		$_POST['q'] = 0;
	if($_POST['q']<0 || $_POST['q']>$total_num_q)
		$_POST['q'] = 1;
}
$curr_q = intval($_POST['q']);
if($curr_q && isset($q_ids[$curr_q-1])){
	$curr_q_id = $q_ids[$curr_q-1];
	$curr_n = array_search($curr_q_id,$qn_ids);
	if (!is_null($curr_n)) $curr_n++;
}else{
	$curr_q_id = 0;
	$curr_n = null;
}
$fields = array('name','type_id','length','precise','required','content','position');
if($updated && $total_num_q > 0 && $curr_q) {
	// survey questions exist already
	// load values from DB
	$sql = "SELECT * FROM ".TABLE_QUESTION." WHERE id='${curr_q_id}' AND deleted='N' ORDER BY position";
	$result = mysql_query($sql);
	$question = mysql_fetch_array($result,MYSQL_ASSOC);
	mysql_free_result($result);
	foreach($fields as $f) {
		$_POST[$f] =& $question[$f];
	}
} else if ($updated && $copy_question==0) {
	// adding a new question (possibly because there are no questions yet)
	$curr_q = 0;
	$curr_q_id = '';
	$num_choices = isset($_POST['num_choices']) ? intval($_POST['num_choices']) : 0;
	for($i=1; $i<$num_choices+1; ++$i) {
		unset($_POST["choice_content_$i"]);
	}
	foreach(array('name','length','precise','content','position','num_choices') as $f) {
		$_POST[$f] = NULL;
	}
}else{
	// for copy question from other surveys
	foreach($fields as $f) {
        if(!empty($_POST[$f]))
		    $_POST[$f] = _stripslashes($_POST[$f]);
        else
            $_POST[$f] = '';
	}
}

$questions['curr_q_id'] = $curr_q_id;
for($i=1; $i<$total_num_q+1; ++$i) {
	$questions['qnumbers'][] = $i;
}
$questions['qnumbers'][] = _GT_New_Field;
$questions['curr_q'] = $curr_q;
$questions['curr_n'] = $curr_n;

if($updated && empty($_POST['type_id'])) $_POST['type_id'] = 2;
$sql = "SELECT id, type FROM ".TABLE_QUESTION_TYPE." WHERE id != 99";
$result = mysql_query($sql);
$typeIdArr = array();
if ( !defined( BMSURVEY_QTYPE_1) ){
	$lang_typeId = array(
		1   => BMSURVEY_QTYPE_1,
		2   => BMSURVEY_QTYPE_2,
		3   => BMSURVEY_QTYPE_3,
		4   => BMSURVEY_QTYPE_4,
		5   => BMSURVEY_QTYPE_5,
		6   => BMSURVEY_QTYPE_6,
		7   => BMSURVEY_QTYPE_7,
		8   => BMSURVEY_QTYPE_8,
		9   => BMSURVEY_QTYPE_9,
		10  => BMSURVEY_QTYPE_10,
		40  => BMSURVEY_QTYPE_40,
		99  => BMSURVEY_QTYPE_99,
		100 => BMSURVEY_QTYPE_100
	);
}
while(list($key, $val) = mysql_fetch_row($result)) {
	if ( isset( $lang_typeId[$key] ) )
		$typeIdArr["$key"] = $lang_typeId[$key];
	else
		$typeIdArr["$key"] = $val;
}
if(empty($_POST['length'])) $_POST['length'] = 0;
if(empty($_POST['precise'])) $_POST['precise'] = 0;
if(empty($_POST['required'])) $_POST['required'] = 'N';
$questions['input'] = array(
	'name'=>$surveyFrom->mktext('name',12),
	'type_id'=>$surveyFrom->mkselect('type_id',$typeIdArr),
	'length'=>$surveyFrom->mktext("length",6),
	'precise'=>$surveyFrom->mktext("precise",6),
	'required'=>$surveyFrom->mkselect("required",array(	"Y" => _GT_Yes, "N" => _GT_No)),
	'content'=>$surveyFrom->mktextarea("content",4,60,"VIRTUAL")
);
$xoopsTpl->assign('questions',$questions);


$tpl_vars['content']['tab'] = array(
	'title' => _GT_Questions,
	'name' => 'questions',
	'description' => ''
);
$tpl_vars['content']['questionNav'] = array();
for($i=0; $i<$total_num_q; ++$i) {
	$numAsJustQuestion = array_search($i, $qn_ids);
	$tpl_vars['content']['questionNav'][] = array(
		'num' => $i+1,
		'numAsJustQuestion' => $numAsJustQuestion,
		'isCurrent' => $i+1 == $curr_q ? 1 : 0,
		'name' => isset($qn_name[$i]) ? $qn_name[$i] : '',
		'typeId' => isset($qn_typeid[$i]) ? $qn_typeid[$i] : '',
		'typeName' => isset($qn_typeid[$i]) && isset($typeIdArr[$qn_typeid[$i]]) ? $typeIdArr[$qn_typeid[$i]] : ''
	);
}
$tpl_vars['content']['currentQuestion'] = array(
	'id' => $curr_q_id,
	'num' => $curr_q ,
	'numAsJustQuestion' => $curr_n,
	'questionInfos' => array(
		'name' => array(
			'input' => $surveyFrom->mktext('name',12),
			'label' => _GT_Field_Name,
			'restrictions' => array(_GT_alpha_numeric_only)
		),
		'type_id' => array(
			'input' => $surveyFrom->mkselect('type_id',$typeIdArr),
			'label' => _GT_Type
		),
		'length' => array(
			'input' => $surveyFrom->mktext("length",6),
			'label' => _GT_Length
		),
		'precise' => array(
			'input' => $surveyFrom->mktext("precise",6),
			'label' => _GT_Precision
		),
		'required' => array(
			'input' => $surveyFrom->mkselect("required",array("Y" => _GT_Yes, "N" => _GT_No)),
			'label' => _GT_Required
		),
		'content' => array(
			'input' => $surveyFrom->mktextarea("content",4,60,"VIRTUAL"),
			'label' => BMSURVEY_TABS_QUESTIONS_QUESTION_CONTENT
		)
	)
);

$tpl_vars['langs']['question_name'] = _GT_Field_Name;

$tpl_vars['langs']['append_question'] = _GT_New_Field;
$tpl_vars['langs']['append_choice'] = _GT_Add_another_answer_line;
$tpl_vars['langs']['question_number'] = BMSURVEY_TABS_QUESTIONS_QUESTION_NUM;
$tpl_vars['langs']['question_infos'] = BMSURVEY_TABS_QUESTIONS_QUESTION_INFOS;
$tpl_vars['langs']['choices_infos'] = BMSURVEY_TABS_QUESTIONS_CHOICES_INFOS;
$tpl_vars['langs']['field_number'] = BMSURVEY_TABS_QUESTIONS_FIELD_NUM;
$tpl_vars['langs']['field_control'] = BMSURVEY_TABS_QUESTIONS_FIELD_CONTROL;
$tpl_vars['langs']['choices_description'] = BMSURVEY_TABS_QUESTIONS_CHOICES_DESC;

$xoops_module_header = '
<script language="javascript">
function clearTextInputs() {
	var i = 1;
	while (document.phpesp.elements["choice_content_" + i]) {
		document.phpesp.elements["choice_content_" + i].value = "";
		i++;
    }
}
</script>
';

// has answer options ... so show that part of the form
if($curr_q == 0 || empty($_POST['type_id']) ||
	mysql_result(mysql_query("SELECT has_choices FROM ".TABLE_QUESTION_TYPE." WHERE id='" . $_POST['type_id'] ."'"),0,0)=='Y'){
	include($GLOBALS['ESPCONFIG']['include_path']."/tab/questions_options".$GLOBALS['ESPCONFIG']['extension']);
}

$xoopsTpl->assign('xoops_module_header', $xoopsTpl->get_template_vars('xoops_module_header').$xoops_module_header);
?>