<?php

# $Id: status.php,v 1.1.1.1 2005/08/10 12:14:03 yoshis Exp $

// Written by James Flemer
// For eGrad2000.com
// <jflemer@alum.rpi.edu>
// ----
// For Xoops
//   $owner = Suevey owner xoops user id
//   $realm = Permitted xoops group id at survey edit
//   $checkstatus = Check permission of status change by module admin
function xoopsGroupStatus($owner,$realm,$checkstatus=0){
	global $xoopsUser,$xoopsModuleConfig;

	if ( $xoopsUser->isAdmin() || $owner == $xoopsUser->uid() ) return TRUE;
    $groups = $xoopsUser->getGroups();
    if (in_array($realm ,$groups)){
    	if (!$checkstatus || ( $checkstatus && $xoopsModuleConfig['PSTATUS'])){
			return TRUE;
    	}
    }
	return FALSE;
}
//
// Main proc start
//
$sid = isset($_POST['sid']) ? intval($_POST['sid']) : null;
$op = isset($_POST['op']) ? htmlspecialchars ( $_POST['op'] , ENT_QUOTES ) : null;
if(!$sid) $sid = isset($_GET['sid']) ? intval($_GET['sid']) : null;
if(!$op) $op = isset($_GET['op']) ? intval($_GET['op']) : null;

	$bg = '';

	/* operation selected ... */
	if(!empty($op)) {
		$sql = "SELECT status,owner,realm,response_id FROM ".TABLE_SURVEY." WHERE id='${sid}'";
		$result = mysql_query($sql);
		if((list($old_status, $owner, $realm,$response_id) = mysql_fetch_row($result))) {
			$access = false;
			$err = false;
			$status = $old_status;
			// trying to perform some operation
			switch(strtolower($op)) {
				case 'c':	// Clear
					/* only _superuser_s can do this */
					if($xoopsUser->isAdmin()) {
						$access = true;
					} else {
						$access = false;
					}
					$status = 0;
					break;
				case 't':	// test
					/* only the owner or a group editor+design */
					/*if($owner == $xoopsUser->uid() ||
						in_array($realm, array_intersect(
							$_SESSION['acl']['pall'],
							$_SESSION['acl']['pdesign']))) {
						$access = true;
					}*/
					$access = xoopsGroupStatus($owner,$realm);
					$status = $old_status | STATUS_TEST;
					if($old_status & ( STATUS_DELETED | STATUS_DONE | STATUS_ACTIVE ) )
						$err = true;
					break;
				case 'm':	// Edit
					/* only the owner or a group editor+design */
					/*if($owner == $xoopsUser->uid() ||
						in_array($realm, array_intersect(
							$_SESSION['acl']['pall'],
							$_SESSION['acl']['pdesign']))) {
						$access = true;
					}*/
					$access = xoopsGroupStatus($owner,$realm);
					$status = $old_status & ~STATUS_TEST;
					if($old_status & ( STATUS_DELETED | STATUS_DONE | STATUS_ACTIVE ) )
						$err = true;
					else
						response_delete_all($sid,$response_id);
					break;
				case 'a':	// activate
					/* only the owner+stauts or a group editor+status */
					/*if(in_array($realm, $_SESSION['acl']['pstatus']) &&
						($owner == $xoopsUser->uid() ||
						in_array($realm, $_SESSION['acl']['pall']))) {
						$access = true;
					}*/
					$access = xoopsGroupStatus($owner,$realm,1);
					$status = STATUS_ACTIVE;	//$old_status | STATUS_ACTIVE;
					if($old_status & ( STATUS_DELETED | STATUS_DONE ) )
						$err = true;
					else
						response_delete_all($sid,$response_id);
					break;
				case 'e':	// End
					/* only the owner+stauts or a group editor+status */
					/*if(in_array($realm, $_SESSION['acl']['pstatus']) &&
						($owner == $xoopsUser->uid() ||
						in_array($realm, $_SESSION['acl']['pall']))) {
						$access = true;
					}*/
					$access = xoopsGroupStatus($owner,$realm,1);
					$status = $old_status | STATUS_DONE;
					if($old_status & STATUS_DELETED )
						$err = true;
					break;
				case 'd':	// Delete
					/* only the owner+stauts or a group editor+status */
					/*if(in_array($realm, $_SESSION['acl']['pstatus']) &&
						($owner == $xoopsUser->uid() ||
						in_array($realm, $_SESSION['acl']['pall']))) {
						$access = true;
					}*/
					$access = xoopsGroupStatus($owner,$realm,1);
					$status = $old_status | STATUS_DELETED;
					break;
				case 'r':	// Re Activate
					/* only the owner+stauts or a group editor+status */
					/*if(in_array($realm, $_SESSION['acl']['pstatus']) &&
						($owner == $xoopsUser->uid() ||
						in_array($realm, $_SESSION['acl']['pall']))) {
						$access = true;
					}*/
					$access = xoopsGroupStatus($owner,$realm,1);
					$status = STATUS_ACTIVE;	//$old_status | STATUS_ACTIVE;
					if(!$old_status & ( STATUS_DONE ) )
						$err = true;
					break;
			}
			/* superuser overrides all */
			if($xoopsUser->isAdmin()) $access = true;
			$sql = "UPDATE ".TABLE_SURVEY." SET status='${status}' WHERE id='${sid}'";
			if($access || auth_no_access(_GT_to_access_this_survey)) {
				if(!$err) {
					mysql_query($sql);
				} else {
					mkwarn(_GT_Can_not_set_survey_status);
					mkerror(_GT_Status .': '. $old_status);
				}
			}
		}
	}
?>
