<?php
# $Id: tab.php,v 1.1.1.1 2005/08/10 12:14:03 yoshis Exp $
// Written by James Flemer
// For eGrad2000.com
// <jflemer@alum.rpi.edu>

// submit from preview
if (isset($_POST['save'])){
	if ( in_array($_POST['save'],array(_GT_SaveAsDefault,_GT_Submit_Survey)) ){
	    // call the handler-prefix once $sid is set to handle
	    // authentication / authorization
	    if ( empty($_POST['rid']) && !empty($_POST['response_id']) ) $_POST['rid']=$_POST['response_id'];
	    if (strcmp($_POST['tab'],'preview')) $overWrite = true;
	    $_POST['submit'] = $_POST['save'];	// You can not use submit when it using java script.
		include($ESPCONFIG['handler']); 	// bmsurvey/public/handler-prefix.php
		$_POST['tab'] = 'general';
	}
}

$surveyFrom = new bmSurveyHtmlForms();

/* This function is a hack to handle input-type=image tags.
 * (e.g.  <input type="image" name="tab" src="clickme.gif"> )
 * You cannot set a 'value' attribute in such a tag. When you
 * click on an image, browsers create two form variables based
 * on the 'name' attribute: <name>_x & <name>_y, the coordinates
 * of where the user clicked on the image.
 *
 * To make this work with my 'where=<module>' wrapper, this
 * function checks for certain variables of the form "blah_x"
 * and "blah_y" and includes 'blah'.
 */
	/*
	session_register('survey_id');
	session_register('new_survey');
	session_register('last_tab');
	session_register('curr_q');
	*/
	/* Use this hack to work around how PHP handles session vars.
	 * When Register_Globals is on, the value of the global $foo
	 * is saved, and $_SESSION['foo'] is ignored.
	 * When Register_Globals is off, the global $foo is ignored
	 * and $_SESSION['foo'] is saved.
	 * By making $_SESSION['foo'] a reference to $foo
	 * when reg_glob is on, we can use $_SESSION uniformly
	 * from here on, regardless of the INI settings.
	 */
	if(ini_get('register_globals')) {
		$_SESSION['survey_id']  = &$survey_id;
		$_SESSION['new_survey'] = &$new_survey;
		$_SESSION['last_tab']   = &$last_tab;
		$_SESSION['curr_q']     = &$curr_q;
	}
	
	global $errstr;
	
	if(@$_POST['where'] == 'new') {
		$bmutil->session_clear($where);
		/*
		$_SESSION['survey_id']  = '';
		$_SESSION['response_id']  = '';
		$_SESSION['new_survey'] = '';
		$_SESSION['last_tab']   = '';
		$_SESSION['curr_q']     = '';
		*/
	}		
	if(!empty($_POST['newid'])) {
		$_SESSION['survey_id']  = intval($_POST['newid']);
		$_POST['tab']           = 'general';
		$_SESSION['last_tab']   = '';
		$_SESSION['new_survey'] = false;
	}
	if(empty($_SESSION['survey_id'])) {
		$_SESSION['survey_id']  = '';
		$_SESSION['new_survey'] = true;
	}
	if(!empty($_SESSION['response_id'])) {
		$_SESSION['response_id']  = intval();;
	}

	if(empty($_SESSION['new_survey']))
		$_SESSION['new_survey'] = empty($_SESSION['survey_id']);

	/* check ACL to see if user is allowed to design
	 * _this_ survey */
	if(!empty($_SESSION['survey_id'])) {
		$srealm = auth_get_survey_realm($_SESSION['survey_id']);
		if($_SESSION['acl']['superuser'] != 'Y' &&
				!auth_is_owner($_SESSION['survey_id'], $xoopsUser->uid()) &&
				!in_array($srealm, array_intersect(
						$_SESSION['acl']['pdesign'],
						$_SESSION['acl']['pall'])) &&
				!auth_no_access(_GT_to_access_this_form)) {
			return;
		}
	}

	/* check user's ACL to see if they have rights to
	 * edit/create _any_ survey */
	if($_SESSION['acl']['superuser'] != 'Y' &&
			count($_SESSION['acl']['pdesign']) < 1 &&
			!auth_no_access(_GT_to_access_this_form)) {
		return;
	}
		

	if(empty($ESPCONFIG['tabs'])) {
		echo('<b>'. _GT_No_tabs_defined . '</b>');
		return;
	}
	
	$tab = &$_POST['tab'];

/* XXX I18n do not translate */
	if(stristr($tab,'continue')) {
		switch($_SESSION['last_tab']) {
			case 'general':
				$tab='questions';
				break;
			case 'questions':
				$tab='order';
				break;
			case 'order':
				$tab='preview';
				break;
			default:
				$tab='general';
		}
	}
/* XXX I18n do not translate */

	if(empty($tab)) {
		foreach($ESPCONFIG['tabs'] as $value) {
//			$x = @$_POST["${tab}_x"];
//			$y = @$_POST["${tab}_y"];
//			if(!empty($x) && !empty($y)) {
//				break;
//			}
			
			if(isset($_POST[$value])){
				$tab = $value;
				break;
			}
			
			$tab = $_SESSION['last_tab'];
		}
	}
	if(empty($tab)){
		$tab = 'general';
	}
	$tab = strtolower(ereg_replace(' +','_',$tab));
	if(!ereg('^[A-Za-z0-9_]+$',$tab))	// Valid chars are [A-Za-z0-9_]
		$tab = 'general';
	if(!file_exists($GLOBALS['ESPCONFIG']['include_path'].'/tab/'.$tab.$GLOBALS['ESPCONFIG']['extension']))
		$tab = 'general';
	if(!file_exists($GLOBALS['ESPCONFIG']['include_path'].'/tab/'.$tab.$GLOBALS['ESPCONFIG']['extension'])) {
		echo('<b>'. _GT_Unable_to_open_include_file. '</b>');
		exit;
	}
	
	$errstr = '';
	$copy_question = 0;
	$updated = survey_update($_SESSION['survey_id'],$tab,$_SESSION['last_tab'],$copy_question);
	$errorMessage = !empty($errstr) ? $errstr : '';
	
	$xoopsTpl->assign('xoops_module_header', '<link href="style.css" media="screen,tv,print" type="text/css" rel="stylesheet" />');
	
	$tpl_vars = array('content' => array(), 'langs' => array(), 'config' => array());
	$tpl_vars['content']['pagetitle'] =  _GT_Edit_a_Survey;
	$tpl_vars['content']['errors'] = array();
	if($errorMessage){
		$tpl_vars['content']['errors'][] = $errorMessage;
	}
	$tpl_vars['content']['hiddens'] = array();
	$tpl_vars['content']['hiddens'][] = array('name' => 'where', 'value' => 'tab');
	$tpl_vars['content']['help'] = $GLOBALS['ESPCONFIG']['manage'].'?where=help';
	$tpl_vars['content']['help2'] = _GT_Click_here_to_open_the_Help_window;
	$tpl_vars['content']['cancelMessage'] = $_SESSION['new_survey'] ? _GT_Click_cancel_to_cancel : '';
	$tpl_vars['content']['guide'] = _GT_The_survey_title_and_other;
	$tpl_vars['content']['tabNav'] = array(
		array(
			'title'=>_GT_General,
			'name'=>"general",
		),
		array(
			'title'=>_GT_Questions,
			'name'=>"questions",
		),
		array(
			'title'=>_GT_Order,
			'name'=>"order",
		),
		array(
			'title'=>_GT_Preview,
			'name'=>"preview",
		),
		array(
			'title'=>_GT_Finish,
			'name'=>"finish",
		)
	);
	$tpl_vars['langs']['help'] = _GT_Help;
	$tpl_vars['config']['currentTab'] = $tab;
	
	//$xoopsTpl->assign('bmsurvey', $tpl_vars);
	
	$_SESSION['last_tab'] = $tab;

	include($GLOBALS['ESPCONFIG']['include_path'].'/tab/'.$tab.$GLOBALS['ESPCONFIG']['extension']);
	
	$xoopsTpl->assign('bmsurvey', $tpl_vars);
	if($tab=='finish') return;
/*
	if($_SESSION['new_survey']) { 
		echo(_GT_Click_cancel_to_cancel); 
		echo '<br><input type="submit" name="where" value="Cancel">';
		if($tab=='preview') { 
			echo '<input type="submit" name="tab" value="Finish">';
			return; 
		}
		echo '&nbsp;<input type="submit" name="tab" value="Continue &gt;">';
		return; 
	}
*/
?>