<?php

# $Id: survey_render.php,v 1.1.1.1 2005/08/10 12:14:03 yoshis Exp $

// Written by James Flemer
// For eGrad2000.com
// <jflemer@alum.rpi.edu>

// Modify by Yoshi Sakai
// For Attach File
// <webmaster@bluemooninc.biz>
// 2004/05/23 Change form style more compact.
// 2004/05/26 Add Attach File.

function maxbyte_str($maxbyte){
	if ($maxbyte>=1000000){
		$maxbyte_str=sprintf("%d M",$maxbyte/1000000);
	} elseif ($maxbyte>=1000){
		$maxbyte_str=sprintf("%d K",$maxbyte/1000);
	} else {
		$maxbyte_str=sprintf("%d ",$maxbyte);
	}
	return $maxbyte_str;
}
/* {{{ proto bool survey_render(int survey_id, int section, string message)
   Reads current form variables from _POST.
   Builds HTML for the survey (prefixed w/ message). */
function survey_render_smarty($sid, $section = 1, $message = '',$rid=NULL) {
	global $xoopsTpl,$maxfilesize,$tpl_vars;
	global $_POST,$xoopsModuleConfig;
	@reset($_POST);

	$tpl_vars['content']['questions'] = array();
	
	if(empty($section)) $section = 1;
	$has_choices = esp_type_has_choices();

	// load survey title (and other globals)
	$sql = "SELECT * FROM ".TABLE_SURVEY." WHERE id='${sid}'";
	$result = mysql_query($sql);
	if(mysql_num_rows($result) != 1) return(false);
	$survey = mysql_fetch_array($result,MYSQL_ASSOC);
	$defval = "";
	//  modify data okamoto
	if (empty($rid )) {      
    	if (!isset($_POST['submit'])){
			$rid = $survey['response_id'];
			$defval = response_select_defval($sid,$rid);
		}
		mysql_free_result($result);
	} else {
		$defval = response_select_defval($sid,$rid);
	}

//	var_dump($defval);
//      print_r($GLOBALS);
//  exit;
//   ----------------------------------------------------
	$sections = survey_get_sections($sid);
	$num_sections = count($sections);
	if($section-- > $num_sections) return(false);	// invalid section

    $section_questions = survey_get_section_questions($sid);

	// load survey questions
	$sec_sql = array_to_insql($sections[$section]);
	$sql = "SELECT * FROM ".TABLE_QUESTION." WHERE id $sec_sql ORDER BY position,id";
	$questions_result = mysql_query($sql);
	if(mysql_num_rows($questions_result) < 1) return(false);
	// check to see if there are required questions
	$sql = "SELECT COUNT(*) FROM ".TABLE_QUESTION." WHERE id $sec_sql AND required='Y'";
	$has_required = mysql_result(mysql_query($sql),0,0);

	// find out what question number we are on $i
	$i=0;
	for($j=0;$j<$section;$j++) $i += count($section_questions[$j]);
	$editq = $i;
	$xoopsTpl->assign('survey',$survey);
	$tpl_vars['content']['survey'] = $survey;
	$xoopsTpl->assign('message',$message);
	$tpl_vars['content']['survey']['message'] = $message;
	$tpl_vars['content']['survey']['page'] = $num_sections > 1 ? mb_('Page '.number_format($section+1).' of '.number_format($num_sections)) : '';
	$tpl_vars['content']['survey']['has_required'] = $has_required ? _MD_ASTERISK_REQUIRED : '';
	if($num_sections>1) {
		$xoopsTpl->assign('surveyPage',mb_('Page '.number_format($section+1).' of '.number_format($num_sections) ));
	}
	if($has_required) {
    	$xoopsTpl->assign('has_required',_MD_ASTERISK_REQUIRED);
	}
	$cid = "" ;
	$surveyFrom = new bmSurveyHtmlForms();
	$surveyFrombody = array();
	$i = $qnum = 1;
	while($question = mysql_fetch_array($questions_result,MYSQL_ASSOC)) {
		$res = array();
		// process each question
		$qid  = &$question['id'];
		$tid  = &$question['type_id'];
		$size = &$question['length'];
		$prec = &$question['precise'];
		// Section Text
		if ($tid == 100) {
			$res['number'] = '';
			$res['content'] = $question['content'];
			$res['body'] ='';
			$surveyFrombody[$i] = $res;
			$tpl_vars['content']['questions'][$qid] = $question;
			++$i;
			continue;
		}
		if($has_choices[$tid]) {
			$sql = "SELECT * FROM ".TABLE_QUESTION_CHOICE." WHERE question_id='$qid' AND content NOT LIKE '!other%' ORDER BY id";
			$choices_result = mysql_query($sql);
			$sql = "SELECT * FROM ".TABLE_QUESTION_CHOICE." WHERE question_id='$qid' AND content LIKE '!other%' ORDER BY id";
			$others_result = mysql_query($sql);
			$others = mysql_num_rows($others_result);
		} else {
			$choices_result = ''; 
		}
		$qname = "Q" . $qid;
		$question['qnum']=$qnum;
		$res['number']='';
		if($question['required']=='Y') { 
			$res['number']='<font color="#FF0000">*</font>'; 
		}
		$res['number'] = $res['number'].'<A NAME="Q'.$qnum.'">'.$qnum.'</A>';
		$res['editq'] = $editq + $qnum;
		if ($tid==8){
			// for ranking title
			$patterns = "/\[TH](.*)\[\/TH\]/si";
			$replacements = '';
			$res['content'] = preg_replace($patterns, $replacements, $question['content']);
			$question['th_title'] = array();
			if (preg_match($patterns, $question['content'], $thstr))
				$th_title = explode( "," , $thstr[1] );
			else
				$th_title = array(1,2,3,4,5);
			$question['th_title'] = $th_title;
		}else{
			$res['content'] = $question['content'];
		}
		$question['content'] = $res['content'];
		$res['body'] ='';
//		echo "qid[".$qid."]tid[".$tid."]value[".$defval[$qname]."]<BR>";
		$body = array();
		switch($tid) {
			case '1':	// Yes/No
				$res['body'] = 
					$surveyFrom->mkradio($qname,'Y',$defval,_GT_Yes)." "._GT_Yes
					.$surveyFrom->mkradio($qname,'N',$defval,_GT_No)." "._GT_No;
				$res['body'] .= $xoopsModuleConfig['RESET_RB'] ? '&nbsp' . $surveyFrom->mkradioCancel($qname,_MD_BMSURVEY_CHECKRESET) : '';
				break;
			case '2':	// single text line
				$res['body'] = $surveyFrom->mktext($qname, $size, $prec,$defval);
				break;
			case '3':	// essay
				$res['body'] = $surveyFrom->mktextarea($qname, $prec, $size, 'VIRTUAL',$defval);
				break;
			case '4':	// radio
				while($choice = mysql_fetch_array($choices_result,MYSQL_ASSOC)) {
					$res['body'] = $res['body'].$surveyFrom->mkradio($qname,$choice['id'],$defval,$choice['content'])." ".$choice['content'];
				}
				$j=0;
				while($other = mysql_fetch_array($others_result,MYSQL_ASSOC)) {
					$cid = $other['id'];
					$other_text = preg_replace(
							array("/^!other=/","/^!other/"),
							array('',_MD_QUESTION_OTHER),
							$other['content']);
					$res['body'] .= $surveyFrom->mkradio($qname,"other_$cid",$defval,$other_text);
					$res['body'] .= "$other_text ";
					$cid = "Q${qid}_${cid}";
					$value = null;
					if (isset($defval[$cid])) $value = $defval[$cid];
					if (isset($GLOBALS['_POST'][$cid])) $value = $GLOBALS['_POST'][$cid];
					$res['body'] .= $surveyFrom->mkother($cid,$value);
					$j++;
				}
				$res['body'] .= $xoopsModuleConfig['RESET_RB'] ? '&nbsp' . $surveyFrom->mkradioCancel($qname,_MD_BMSURVEY_CHECKRESET) : '';
				break;
			case '5':	// check boxes
				if ( $prec==0 ) $res['content'] .= _MD_BMSURVEY_CHECKANY;
				else  $res['content'] .= sprintf(_MD_BMSURVEY_CHECKLIMIT,$prec);
				$num_rows = mysql_num_rows($choices_result); 
				$num_alt=0;
				if ($num_rows > 3) $num_alt = ceil( $num_rows / 2 );
				$num=0;
				while($choice = mysql_fetch_array($choices_result,MYSQL_ASSOC)) {	
					if ( ($num_alt>0) && ($num==$num_alt) ){
					}
					$res['body'] = $res['body'].$surveyFrom->mkcheckbox($qname,$choice['id'],$defval,$choice['content'])." ".$choice['content'];
					$num++;
				}
				$j=0;
				while($other = mysql_fetch_array($others_result,MYSQL_ASSOC)) {
					$cid = $other['id'];
					$other_text = preg_replace(array("/^!other=/","/^!other/"),array('',_MD_QUESTION_OTHER),$other['content']);
					$res['body'] .= $surveyFrom->mkcheckbox($qname,$cid,$defval,$other_text);
					$res['body'] .= "$other_text ";
					$cid = "Q${qid}_${cid}";
					$value = null;
					if (isset($defval[$cid])) $value = $defval[$cid];
					if (isset($GLOBALS['_POST'][$cid])) $value = $GLOBALS['_POST'][$cid];
					$res['body'] .= $surveyFrom->mkother($cid,$value);
					$j++;
				}
				break;
			case '6':	// dropdown box
				$options = array();
				while($choice = mysql_fetch_array($choices_result,MYSQL_ASSOC)) {
					$options[$choice['id']] = $choice['content'];
				}
				$res['body'] = $surveyFrom->mkselect($qname,$options,$defval);
				break;
			case '7':	// rating
				$res['body'] = '<table border="0" cellspacing="0" cellpadding="0"><tr>';
				$res['body'] = $res['body'].'<td width="60">'.$surveyFrom->mkradio($qname,1)." ".mb_('1').'</td>';
				$res['body'] = $res['body'].'<td width="60">'.$surveyFrom->mkradio($qname,2)." ".mb_('2').'</td>';
				$res['body'] = $res['body'].'<td width="60">'.$surveyFrom->mkradio($qname,3)." ".mb_('3').'</td>';
				$res['body'] = $res['body'].'<td width="60">'.$surveyFrom->mkradio($qname,4)." ".mb_('4').'</td>';
				$res['body'] = $res['body'].'<td width="60">'.$surveyFrom->mkradio($qname,5)." ".mb_('5').'</td>';
				$res['body'] = $res['body'].'<td width="60">'.$surveyFrom->mkradio($qname,'N/A')." ".mb_('N/A').'</td></tr></table>';
				break;
			case '8':	// ranking
				/*
				$bg = '#eeeeee';	// bgcolor
				$res['body'] = '<table border="0" cellspacing="1" cellpadding="0" height="120%"><tr><td width="25%"></td>';
				for ($j = 0; $j < $size; $j++) {
					$res['body'] = $res['body'].
						'<td width="8%" align="center" bgcolor="'.$bg.'">'.$th_title[$j].'</td>';	//number_format($j+1)
					if ($bg == '#eeeeee')   $bg = '#dddddd';
					else                    $bg = '#eeeeee';
				}
				if ($prec) {
					$res['body'] = $res['body'].
						'<td width="30%" align="center" bgcolor="'.$bg.'">'._GT_NA.'</td>';
				}
				$res['body'] .= '</tr>';
				*/
				$rankArray=array();
				while($choice = mysql_fetch_array($choices_result,MYSQL_ASSOC)) {
					$cid = $choice['id'];
					$qname = "Q${qid}_$cid";
					$res['body'] .= '<tr><td width="35%" align="left">'.$surveyFrom->mkrankTitle($qname,$choice['content']);
					$res['body'] .= $xoopsModuleConfig['RESET_RB'] ? '&nbsp' . $surveyFrom->mkradioCancel($qname,_MD_BMSURVEY_CHECKRESET) : '';
					$res['body'] .= '</td>';
					$bg = '#eeeeee';
					for ($j = 0; $j < $size; $j++) {
						$res['body'] = $res['body'].
							'<td width="8%" align="center" bgcolor="'.$bg.'">'.$surveyFrom->mkradio($qname,$j,null,$th_title[$j]).'</td>';
						if ($bg == '#eeeeee')   $bg = '#dddddd';
						else                    $bg = '#eeeeee';
					}
					if ($prec) {
						$res['body'] = $res['body'].
							'<td width="35%" align="center" bgcolor="'.$bg.'">'.$surveyFrom->mkradio($qname,'N/A').'</td>';
					}
					$res['body'] = $res['body']."</tr>";
					$rankArray[] = $surveyFrom->getHtmlTag();
				}
				$surveyFrom->htmlTag = $rankArray;
				$res['body'] = $res['body']."</table>";
				break;
			case '9':	// date
				$varr[$qname] = date(_SHORTDATESTRING, time());
				$res['body'] = $surveyFrom->mktext($qname, 10, 10,$varr,$defval).'<em>(e.g. '.date(_SHORTDATESTRING, time()).')</em>';
				break;
			case '10':	// numeric
				$size++; // for sign
				if($prec) $size += 1 + $prec;
				$res['body'] = $surveyFrom->mktext($qname, $size, $size,$defval);
				break;
			case '40':	// Attache
				$res['body'] .= $surveyFrom->mkattach($qname,$size,$maxfilesize);
				break;
		}
		$tpl_vars['content']['questions'][$qid] = $question;
		$tpl_vars['content']['questions'][$qid]['htmlTag'] =$surveyFrom->getHtmlTag();
		
		// end of select
		$surveyFrombody[$i] = $res;
		$i++; $qnum++;
	}
	// end of questions
	if($num_sections>1) {
		$res['body'] = $res['body'].'<font size="-1" class="surveyPage">'.mb_('Page')
			.number_format($section+1).mb_('of').number_format($num_sections);
	} /*  exit;  */

	return $surveyFrombody;
}
/******************************************************************************
** For email
******************************************************************************/
function survey_render_email($sid, $section = 1, $message = '', $hide_question = 0) {
	global $_POST,$maxfilesize;
	@reset($_POST);
	$body='';

	if(empty($section)) $section = 1;

	$has_choices = esp_type_has_choices();

// load survey title (and other globals)
	$sql = "SELECT * FROM ".TABLE_SURVEY." WHERE id='${sid}'";
	$result = mysql_query($sql);
	if(mysql_num_rows($result) != 1)
		return(false);
	$survey = mysql_fetch_array($result,MYSQL_ASSOC);
	mysql_free_result($result);

	$sections = survey_get_sections($sid);
	$num_sections = count($sections);
	if($section-- > $num_sections)
		return(false);	// invalid section

    $section_questions = survey_get_section_questions($sid);

// load survey questions
	$sec_sql = array_to_insql($sections[$section]);
	$sql = "SELECT * FROM ".TABLE_QUESTION." WHERE id $sec_sql ORDER BY position,id";
	$questions_result = mysql_query($sql);
	if(mysql_num_rows($questions_result) < 1)
		return(false);

// check to see if there are required questions
	$sql = "SELECT COUNT(*) FROM ".TABLE_QUESTION." WHERE id $sec_sql AND required='Y'";
	$has_required = mysql_result(mysql_query($sql),0,0);

// find out what question number we are on $i
	$i=0;
	for($j=0;$j<$section;$j++) $i += count($section_questions[$j]);
	$title = $survey["title"];
	if ($survey["subtitle"]){
		$title .=" ".$survey["subtitle"];
	}
	if ($survey["info"] || $message){
		$title .= "\n".$survey["info"]." ".$message;
	}
/*
	if($has_required) {
	   	$title .= "\n"._MD_ASTERISK_REQUIRED;
	}
*/
	$body = "";
	//$i = $qnum = 1;
	while($question = mysql_fetch_array($questions_result,MYSQL_ASSOC)) {
		// process each question
		$qnum = &$question['position'];
		$qid  = &$question['id'];
		$tid  = &$question['type_id'];
		$size = &$question['length'];
		$prec = &$question['precise'];
		if ($tid == 100) {
			$body.= "// " . $question['content'] . "\r\n";
			continue;
		}
		++$i;
		if($has_choices[$tid]) {
			$sql = "SELECT * FROM ".TABLE_QUESTION_CHOICE." WHERE question_id='$qid' AND content NOT LIKE '!other%' ORDER BY id";
			$choices_result = mysql_query($sql);
			$sql = "SELECT * FROM ".TABLE_QUESTION_CHOICE." WHERE question_id='$qid' AND content LIKE '!other%' ORDER BY id";
			$others_result = mysql_query($sql);
			$others = mysql_num_rows($others_result);
		} else {
			$choices_result = '';
		}
		if($question['required']=='Y') { 
			$body.='[*]'; 
		}
		if ($hide_question==0)
			$content = $question['content'];
		else
			$content = '';
		//'Q'.  $qnum + 1 . ':' . $question['content'];	//$qid 
		$body .= sprintf("Q%u:%s",$qnum+1 ,$content);
		switch($tid) {
			case '1':	// Yes/No
				$body.=" 1.()Yes";
				$body.=" 2.()No";
				break;
			case '2':	// single text line
				$body .= sprintf(" []M%uL%u",$size,$prec);
				break;
			case '3':	// essay
				$body .= sprintf(" []R%uC%u",$size,$prec);
				break;
			case '4':	// radio
				$j=1;
				while($choice = mysql_fetch_array($choices_result,MYSQL_ASSOC)) {
					$body.=' '.$choice['id'].'.()';	//(mkradio($qid,$choice['id']));
					$body.=$choice['content'];
					$j++;
				}
				$j=0;
				while($other = mysql_fetch_array($others_result,MYSQL_ASSOC)) {
					$cid = $other['id'];
					$other_text = preg_replace(
						array("/^!other=/","/^!other/"),
						array('',_MD_QUESTION_OTHER),
						$other['content']);	//'Other:'
					$body.= "\r\n   o_${cid}:${other_text}[]";	//${qid}
//					$body.=mkradio($qid,"other_$cid");
//                    $cid = "${qid}_${cid}";
                    //$body.="$other_text <input type=\"text\" size=\"20\" name=\"$cid\" onKeyPress=\"other_check(this.name)\"";
//                	if (isset($GLOBALS['_POST'][$cid]))
//                        $body.=(' value="'. htmlspecialchars($GLOBALS['_POST'][$cid]) .'"');
//                    $body.=(" />");
					$j++;
				}
				break;
			case '5':	// check boxes
				$num=0;
				while($choice = mysql_fetch_array($choices_result,MYSQL_ASSOC)) {	
					$num++;
					//$body.=(mkcheckbox($qid,$choice['id'])); 
					$body.=' '.$choice['id'].'.[]';
					$body.=$choice['content'];
				}
				$j=0;
				while($other = mysql_fetch_array($others_result,MYSQL_ASSOC)) {
					$cid = $other['id'];
					$other_text = preg_replace(
						array("/^!other=/","/^!other/"),
						array('',_MD_QUESTION_OTHER),
					$other['content']);
					$body.= "\r\n   o_${cid}:${other_text}[]";	//${qid}
/*
					$body.=(mkcheckbox($qid,"other_$cid"));
                    $cid = "${qid}_${cid}";
                    $body.=("$other_text <input type=\"text\" size=\"20\" name=\"$cid\" onKeyPress=\"other_check(this.name)\"");
                	if (isset($GLOBALS['_POST'][$cid]))
                        $body.=(' value="'. htmlspecialchars($GLOBALS['_POST'][$cid]) .'"');
                    $body.=(" />");
*/
					$j++;
				}
				break;
			case '6':	// dropdown box
				$options = array();
				while($choice = mysql_fetch_array($choices_result,MYSQL_ASSOC)) {
//					$options[$choice['id']] = $choice['content'];
					$body.= ' '.$choice['id'].'.()';
					$body.= $choice['content'];
				}
				//$body.=(mkselect($qid,$options));
				break;
			case '7':	// rating
				$body.='[]1[]2[]3[]4[]5';
				$body.=('N/A');
				break;
			case '8':	// ranking
				while($choice = mysql_fetch_array($choices_result,MYSQL_ASSOC)) {
					$cid = $choice['id'];
					$body.="\r\n${qid}_${cid}:";
					$body.=$choice['content'];
					if ($prec) {
						$body .= 'N/A';
					}else{
						for ($j = 0; $j < $size; $j++) {
							$body .= sprintf(' %u.()',$j+1);
						}
					}
				}
				break;
			case '9':	// date
				$body .= sprintf(" [%s]M%uL%uN",date(_SHORTDATESTRING, time()),$size,$prec);
				break;
			case '10':	// numeric
				$body .= sprintf(" []M%uL%uN",$size,$prec);
				break;
			case '40':	// Attache
				//$body.=(mktext($qid, $size, $prec));
				$body.= "<INPUT TYPE='hidden' NAME='MAX_FILE_SIZE' VALUE='".$maxfilesize."'>";
				$body.= "<INPUT type='file' size='".$size."' name='".$qid."' /> Max ".maxbyte_str($maxfilesize)."Byte.";
				break;
		}
		// end of select
		$body .= "\r\n";
	}
	// end of questions
	$myts =& MyTextSanitizer::getInstance();
	$ret['title']=$title;
	$ret['body']=$myts->stripSlashesGPC($body);
	return $ret;
	//return $body;
}
?>