<?php
# $Id: handler.php,v 1.1.1.1 2005/08/10 12:14:04 yoshis Exp $
// Written by James Flemer
// For eGrad2000.com
// <jflemer@alum.rpi.edu>
/* When using the authentication for responses you need to include
 * part of the script *before* your template so that the
 * HTTP Auth headers can be sent when needed.
 *
 * See the handler-prefix.php file for details.
 */
$survey_preview = isset( $where ) ? true : false;
if (!$survey_preview) $overWrite = false;

if (!defined('ESP_BASE')) define('ESP_BASE', dirname(dirname(__FILE__)) .'/');
require_once(ESP_BASE . '/admin/phpESP.ini.php');
require_once($ESPCONFIG['include_path']."/funcs".$ESPCONFIG['extension']);
require_once($ESPCONFIG['handler_prefix']);
/*
if(!defined('ESP-AUTH-OK')) {
	$tpl_vars['content']['error'] =  "handler.php[17]".$GLOBALS['errmsg'];
	$xoopsTpl->assign('bmsurvey', $tpl_vars);
	return;
}
*/
//esp_init_db();
$_sec = $_POST['sec'] ? intval($_POST['sec']) : 0;
$_rid = $_POST['rid'] ? intval($_POST['rid']) : 0;
$_userid = $_POST['userid'] ? intval($_POST['userid']) : 0;

if (empty($_POST['referer'])) $_POST['referer'] = '';
// show results instead of show survey
// but do not allow getting results from URL or FORM
if(isset($results) && $results) {
	// small security issue here, anyone could pick a QID to crossanalyze
	survey_results($sid,$precision,$totals,$qid,$cids);
	return;
}
// else draw the survey
$sql = "SELECT status, name FROM ".TABLE_SURVEY." WHERE id='${sid}'";
$result = mysql_query($sql);
if ($result && mysql_num_rows($result) > 0){
	list ($status, $name) = mysql_fetch_row($result);
}else
    $status = 0;
if ( !$survey_preview ){
	if($status & ( STATUS_DONE | STATUS_DELETED )) {
		$tpl_vars['content']['error'] =  "handler.php[38]". _GT_Survey_is_not_active;
	}
	if(!($status & STATUS_ACTIVE)) {
		if(!(isset($test) && $test && ($status & STATUS_TEST))) {
			$tpl_vars['content']['error'] = "handler.php[43]". _GT_Survey_is_not_active ;
		}
	}
}
if ($_POST['referer'] == $ESPCONFIG['autopub_url'])
    $_POST['referer'] .= "?name=$name";

$num_sections = survey_num_sections($sid);
$msg = '';
$flg ="1";
//$action = 'http://' . $_SERVER['HTTP_HOST'] . $_SERVER['PHP_SELF'];
$action = $_SERVER['PHP_SELF'];

if (!empty($_SERVER['QUERY_STRING']))
	$action .= "?" . $_SERVER['QUERY_STRING'];

/*
** Save / Resume User Response
*/
if( $status && !($status & ( STATUS_DONE | STATUS_DELETED )) ) {
	if(!empty($_POST['submit'])) {
		$msg = response_check_required($sid,$_sec);
		if(empty($msg)) {
	        if ( $overWrite || ($ESPCONFIG['auth_response'] && auth_get_option('resume')) )
	            response_delete($sid, $_rid, $_sec,$flg);
			$_rid = response_insert($sid,$_sec,$_rid);
			response_commit($_rid);
			// return to manage.php
			if ( $survey_preview == true ) return;
			response_send_email($sid,$_rid);
			$msg = goto_thankyou($sid,$_POST['referer']);
			if (!$msg) $msg=_MD_BMSURVEY_THANKS_ENTRY;
			redirect_header($_POST['referer'],2,$msg);	//$referer
			return;
		}
	}
	if(!empty($_POST['resume']) && $ESPCONFIG['auth_response'] && auth_get_option('resume')) {
	    response_delete($sid, $_rid, $_sec);
		$_rid = response_insert($sid,$_sec,$_rid);
	    if ($action == $ESPCONFIG['autopub_url'])
			goto_saved("$action?name=$name");
	    else
	        goto_saved($action);
		return;
	}
	if ($ESPCONFIG['auth_response'] && auth_get_option('resume')){
	    response_import_sec($sid, $_rid, $_sec);
	}
}
/*
** Page navigation
*/
if(!empty($_POST['next'])) {
	$msg = response_check_required($sid,$_sec);
	if(empty($msg)) {
        if ($ESPCONFIG['auth_response'] && auth_get_option('resume'))
            response_delete($sid, $_rid, $_sec);
		$_rid = response_insert($sid,$_sec,$_rid);
		$_sec++;
	}
}
if (!empty($_POST['prev']) && $ESPCONFIG['auth_response'] && auth_get_option('navigate')) {
	if(empty($msg)) {
        if (auth_get_option('resume'))
            response_delete($sid, $_rid, $_sec);
		$_rid = response_insert($sid,$_sec,$_rid);
		$_sec--;
	}
}
/*
** Display form body. Call Render with Smarty
*/
$xoopsTpl->assign('formheader', array(
	'action' => $action,
	'referer' => htmlspecialchars($_POST['referer']),
	'userid' => $_userid,
	'sid' => $sid,
	'rid' => $_rid,
	'sec' => $_sec)
);
if(!isset($tpl_vars)){ $tpl_vars = array('content' => array(), 'langs' => array(), 'config' => array()); }
$tpl_vars['content']['form'] = array('action' => $action, 'name' => 'phpesp_response', 'enctype' => 'multipart/form-data');
$tpl_vars['content']['hiddens'] = array(
	'referer' => htmlspecialchars($_POST['referer']),
	'userid' => $_userid,
	'sid' => $sid,
	'rid' => $_rid,
	'sec' => $_sec
);


//$xoopsTpl->assign('formbody',survey_render_smarty($sid,$_sec,$msg,$_rid));

survey_render_smarty($sid,$_sec,$msg,$_rid);

$tpl_vars['content']['buttons'] = array();
if ($ESPCONFIG['auth_response']) {
	if (auth_get_option('navigate') && $_sec > 1) { 
		$xoopsTpl->assign('auth_response','<input type="submit" name="prev" value="Previous Page">');
		$tpl_vars['content']['buttons']['prev'] = array('label' => 'Previous Page', 'name' => 'prev', 'type' => 'submit');
	}
	if (auth_get_option('resume')) {
		$xoopsTpl->assign('auth_response','<input type="submit" name="resume" value="Save">');
		$tpl_vars['content']['buttons']['save'] = array('label' => 'Save', 'name' => 'resume', 'type' => 'submit');
	}
}
if($_sec == $num_sections)	{
	$xoopsTpl->assign('formfooter', array('name' =>'submit','value'=>_MD_SUBMIT_SURVEY));
	$tpl_vars['content']['buttons']['submit'] = array('label' => _MD_SUBMIT_SURVEY, 'name' => 'submit', 'type' => 'submit');
} else {
	$xoopsTpl->assign('formfooter', array('name' =>'next','value'=>_MD_NEXT_PAGE));
	$tpl_vars['content']['buttons']['next'] = array('label' => _MD_NEXT_PAGE, 'name' => 'next', 'type' => 'submit');
}
$xoopsTpl->assign('bmsurvey', $tpl_vars);
?>
